<?php

namespace App\Policies;

use Illuminate\Auth\Access\Response;
use App\Models\ModuleList;
use App\Models\User;

class ModuleListPolicy
{
    /**
     * Determine whether the user can view any models.
     */
    public function viewAny(User $user): bool
    {
        return $user->checkPermissionTo('view-any ModuleList');
    }

    /**
     * Determine whether the user can view the model.
     */
    public function view(User $user, ModuleList $modulelist): bool
    {
        return $user->checkPermissionTo('view ModuleList');
    }

    /**
     * Determine whether the user can create models.
     */
    public function create(User $user): bool
    {
        return $user->checkPermissionTo('create ModuleList');
    }

    /**
     * Determine whether the user can update the model.
     */
    public function update(User $user, ModuleList $modulelist): bool
    {
        return $user->checkPermissionTo('update ModuleList');
    }

    /**
     * Determine whether the user can delete the model.
     */
    public function delete(User $user, ModuleList $modulelist): bool
    {
        return $user->checkPermissionTo('delete ModuleList');
    }

    /**
     * Determine whether the user can delete any models.
     */
    public function deleteAny(User $user): bool
    {
        return $user->checkPermissionTo('delete-any ModuleList');
    }

    /**
     * Determine whether the user can restore the model.
     */
    public function restore(User $user, ModuleList $modulelist): bool
    {
        return $user->checkPermissionTo('restore ModuleList');
    }

    /**
     * Determine whether the user can restore any models.
     */
    public function restoreAny(User $user): bool
    {
        return $user->checkPermissionTo('restore-any ModuleList');
    }

    /**
     * Determine whether the user can replicate the model.
     */
    public function replicate(User $user, ModuleList $modulelist): bool
    {
        return $user->checkPermissionTo('replicate ModuleList');
    }

    /**
     * Determine whether the user can reorder the models.
     */
    public function reorder(User $user): bool
    {
        return $user->checkPermissionTo('reorder ModuleList');
    }

    /**
     * Determine whether the user can permanently delete the model.
     */
    public function forceDelete(User $user, ModuleList $modulelist): bool
    {
        return $user->checkPermissionTo('force-delete ModuleList');
    }

    /**
     * Determine whether the user can permanently delete any models.
     */
    public function forceDeleteAny(User $user): bool
    {
        return $user->checkPermissionTo('force-delete-any ModuleList');
    }
}
